<?xml version="1.0" encoding="utf-8" ?>
<doctrine-mapping
        xmlns="http://doctrine-project.org/schemas/orm/doctrine-mapping"
        xmlns:gedmo="http://gediminasm.org/schemas/orm/doctrine-extensions-mapping"
        xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
        xsi:schemaLocation="http://doctrine-project.org/schemas/orm/doctrine-mapping
                            https://raw.github.com/doctrine/doctrine2/master/doctrine-mapping.xsd">

    <entity name="App\Domain\Registry\Model\Violation" table="registry_violation">

        <id name="id" column="id" type="uuid"/>

        <field name="date" column="date" type="date"/>
        <field name="inProgress" column="in_progress" type="boolean"/>
        <field name="violationNature" column="violation_nature"/>
        <field name="origins" column="origins" type="json_array"/>
        <field name="cause" column="cause"/>
        <field name="concernedDataNature" column="concerned_data_nature" type="json_array"/>
        <field name="concernedPeopleCategories" column="concerned_people_categories" type="json_array"/>
        <field name="nbAffectedRows" column="nb_affected_rows" type="integer"/>
        <field name="nbAffectedPersons" column="nb_affected_persons" type="integer"/>
        <field name="potentialImpactsNature" column="potential_impacts_nature" type="json_array"/>
        <field name="gravity" column="gravity"/>
        <field name="communication" column="communication"/>
        <field name="communicationPrecision" column="communication_precision" type="text" nullable="true"/>
        <field name="appliedMeasuresAfterViolation" column="applied_measures_after_violation" type="text" nullable="true"/>
        <field name="notification" column="notification" nullable="true"/>
        <field name="notificationDetails" column="notification_details" nullable="true"/>
        <field name="comment" column="comment" type="text" nullable="true"/>

        <many-to-many field="proofs" target-entity="App\Domain\Registry\Model\Proof" mapped-by="violations">
            <order-by>
                <order-by-field name="name"/>
            </order-by>
        </many-to-many>

        <!-- Traits -->
        <many-to-one field="collectivity" target-entity="App\Domain\User\Model\Collectivity"/>
        <many-to-one field="creator" target-entity="App\Domain\User\Model\User"/>
        <field name="createdAt" column="created_at" type="datetime_immutable">
            <gedmo:timestampable on="create"/>
        </field>
        <field name="updatedAt" column="updated_at" type="datetime_immutable">
            <gedmo:timestampable on="update"/>
        </field>
        <field name="deletedAt" column="deleted_at" type="datetime_immutable" nullable="true"/>

    </entity>

</doctrine-mapping>
